/*
 * Common keypad server functionality.
 *
 * Copyright (C) 2018, 2023 Paul Boddie <paul@boddie.org.uk>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA
 */

#pragma once

#include <l4/re/c/dataspace.h>

#include "keypad_interface.h"



#ifdef __cplusplus

/* Server object to provide keypad data access. */

class Keypad_server : public Keypad
{
private:
  l4re_ds_t _mem;

public:
  /* Initialise the server with a capability referencing the exported memory. */

  explicit Keypad_server(l4re_ds_t mem)
  : _mem(mem)
  {}

  long get_keypad_data(l4_cap_idx_t *data);
};

#endif
